/*
CRM API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package crmapi

import (
	"encoding/json"
)

// checks if the GetAddressByFormData200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetAddressByFormData200Response{}

// GetAddressByFormData200Response struct for GetAddressByFormData200Response
type GetAddressByFormData200Response struct {
	Available *bool `json:"available,omitempty"`
	Phase *int64 `json:"phase,omitempty"`
}

// NewGetAddressByFormData200Response instantiates a new GetAddressByFormData200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetAddressByFormData200Response() *GetAddressByFormData200Response {
	this := GetAddressByFormData200Response{}
	return &this
}

// NewGetAddressByFormData200ResponseWithDefaults instantiates a new GetAddressByFormData200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetAddressByFormData200ResponseWithDefaults() *GetAddressByFormData200Response {
	this := GetAddressByFormData200Response{}
	return &this
}

// GetAvailable returns the Available field value if set, zero value otherwise.
func (o *GetAddressByFormData200Response) GetAvailable() bool {
	if o == nil || IsNil(o.Available) {
		var ret bool
		return ret
	}
	return *o.Available
}

// GetAvailableOk returns a tuple with the Available field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAddressByFormData200Response) GetAvailableOk() (*bool, bool) {
	if o == nil || IsNil(o.Available) {
		return nil, false
	}
	return o.Available, true
}

// HasAvailable returns a boolean if a field has been set.
func (o *GetAddressByFormData200Response) HasAvailable() bool {
	if o != nil && !IsNil(o.Available) {
		return true
	}

	return false
}

// SetAvailable gets a reference to the given bool and assigns it to the Available field.
func (o *GetAddressByFormData200Response) SetAvailable(v bool) {
	o.Available = &v
}

// GetPhase returns the Phase field value if set, zero value otherwise.
func (o *GetAddressByFormData200Response) GetPhase() int64 {
	if o == nil || IsNil(o.Phase) {
		var ret int64
		return ret
	}
	return *o.Phase
}

// GetPhaseOk returns a tuple with the Phase field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAddressByFormData200Response) GetPhaseOk() (*int64, bool) {
	if o == nil || IsNil(o.Phase) {
		return nil, false
	}
	return o.Phase, true
}

// HasPhase returns a boolean if a field has been set.
func (o *GetAddressByFormData200Response) HasPhase() bool {
	if o != nil && !IsNil(o.Phase) {
		return true
	}

	return false
}

// SetPhase gets a reference to the given int64 and assigns it to the Phase field.
func (o *GetAddressByFormData200Response) SetPhase(v int64) {
	o.Phase = &v
}

func (o GetAddressByFormData200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetAddressByFormData200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Available) {
		toSerialize["available"] = o.Available
	}
	if !IsNil(o.Phase) {
		toSerialize["phase"] = o.Phase
	}
	return toSerialize, nil
}

type NullableGetAddressByFormData200Response struct {
	value *GetAddressByFormData200Response
	isSet bool
}

func (v NullableGetAddressByFormData200Response) Get() *GetAddressByFormData200Response {
	return v.value
}

func (v *NullableGetAddressByFormData200Response) Set(val *GetAddressByFormData200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetAddressByFormData200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetAddressByFormData200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetAddressByFormData200Response(val *GetAddressByFormData200Response) *NullableGetAddressByFormData200Response {
	return &NullableGetAddressByFormData200Response{value: val, isSet: true}
}

func (v NullableGetAddressByFormData200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetAddressByFormData200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


